/******************************************************************************
 *
 * Copyright (c) 2003 Intel Corporation.  All rights reserved.
 *
 * Intel hereby grants you permission to copy, modify, and distribute this
 * software and its documentation.  Intel grants this permission provided
 * that the above copyright notice appears in all copies and that both the
 * copyright notice and this permission notice appear in supporting
 * documentation.  In addition, Intel grants this permission provided that
 * you prominently mark as not part of the original any modifications made
 * to this software or documentation, and that the name of Intel
 * Corporation not be used in advertising or publicity pertaining to the
 * software or the documentation without specific, written prior
 * permission.
 *
 * Intel provides this AS IS, WITHOUT ANY WARRANTY, INCLUDING THE WARRANTY
 * OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, and makes no
 * guarantee or representations regarding the use of, or the results of the
 * use of, the software and documentation in terms of correctness,
 * accuracy, reliability, currentness, or otherwise, and you rely on the
 * software, documentation, and results solely at your own risk.
 *
 **************************************************************************/
/*                                                                        */
/* History:                                                               */
/*  27Feb03  DDM  Initial Release                                         */
/*                                                                        */
/**************************************************************************/

#define SECTION_SIZE (1*1024*1024)

#define DCACHE_SIZE_TOTAL (32*1024)
#define DCACHE_LINE_SIZE  32

#define NTH_CACHE_LINE(v,n)  ((v)[(n)*DCACHE_LINE_SIZE])

#define PRELOAD(v) asm(" pld %0" : : "m" (v))

#define DELAY(w)                                     \
{                                                    \
    register unsigned long _val_ = (w << 1);         \
    if (_val_)  {                                    \
       asm volatile (                                \
           "0:  subs %0,%0,#1  \n"                   \
           "    nop            \n"                   \
           "    nop            \n"                   \
           "    nop            \n"                   \
           "    bne  0b        \n"                   \
           "1:                 \n" : "+r" (_val_) ); \
    }                                                \
}

enum xscale_cache_policy {
    CACHE_POLICY_STALL_UNTIL_COMPLETE,
    CACHE_POLICY_NO_CACHING_BUFFER_COALESCING,
    CACHE_POLICY_WRITE_THROUGH_READ_ALLOCATE,
    CACHE_POLICY_WRITE_BACK_READ_ALLOCATE,
    CACHE_POLICY_NO_CACHING_NO_BUFFER_COALESCING,
    CACHE_POLICY_MINI_DCACHE,
    CACHE_POLICY_WRITE_BACK_READ_WRITE_ALLOCATE
};
extern void cache_control(enum xscale_cache_policy, 
                          void *addr,
                          unsigned long size);

extern inline void timer_start(void);
extern inline unsigned timer_read(void);

extern inline double ticks_to_mb_per_s(unsigned long ticks,
                                       unsigned long size);
